procedure ptv(image,frame)

# ptv -- display image in range determined from iterative mean & sigma
#
# 950808: created
# 981216: negative lsig/hsig values use the absolute value of lsig/hsig
#		for that limit
# 990222: now uses plain old display if iterstat hasn't been done on image

string	image	{prompt="Image to display"}
int	frame	{prompt="Frame to use"}
real	lsig=3	{prompt="Number of sigma below mean for display lower limit"}
real	hsig=10	{prompt="Number of sigma above mean for display upper limit"}

begin

string img
real h_sig, l_sig, mean, sig, val_z1, val_z2

img = image
l_sig = lsig
h_sig = hsig

imgets (img, "itermean", >& "dev$null")
if ((imgets.value)!="0") {
	mean=real(imgets.value)
	imgets (img, "itersig", >& "dev$null")
	if ((imgets.value)!="0") {
		sig=real(imgets.value)
		if (l_sig<0) {
			val_z1=-1*l_sig
		} else {
			val_z1=mean-l_sig*sig
		}
		if (h_sig<0) {
			val_z2=-1*h_sig
		} else {
			val_z2=mean+h_sig*sig
		}
		display (image, frame, zr-, zs-, z1=val_z1, z2=val_z2)
	} else {
		beep
		print ("ITERSIG not found in image header; using display")
		display (image, frame)
	}
} else {
	beep
	print ("ITERMEAN not found in image header; using display")
	display (image, frame)
}

end




