procedure btc_test(im1,im2,im3,prefix,suffix)

# --trim images to areas with < 2/3 (rounded down) of input images
# --align B & R image to overlap region only
# --optionally align I image to that same region
#
# 980710: created
 
string  im1     {prompt="Primary (reference) image"}
string  im2     {prompt="Secondary image"}
string  im3     {prompt="Tertiary image (optional)"}
string  prefix  {prompt="Prefix string for output files"}
string  suffix  {prompt="Suffix string for output files"}
bool domask=yes	{prompt="Mask image areas w/<2/3 max # of input images?"}
bool doalign=yes {prompt="Align & trim images to match each other?"}
bool	delold	{prompt="Delete existing versions of intermediate files?"}
bool   echog        {yes,prompt="Beep when task is done?"}
struct  *name

begin

string  bimage, rimage, iimage, s1, s2, s3, image, pl, imroot, imext
string  imrootr, imrootb, imrooti
real    x, y
int	xmin, ymin, xmax, ymax, i, j, k, numim, imnow, maxfrac, n
int	bxmin, bxmax, bymin, bymax, rxmax, rxmin, rymax, rymin, xoff, yoff
int	rxminoff, rxmaxoff, ryminoff, rymaxoff, ixmin, ixmax, iymin, iymax
int	bxnewmin, bxnewmax, bynewmin, bynewmax, rxnewmin, rxnewmax
int	rynewmin, rynewmax, ixnewmin, ixnewmax, iynewmin, iynewmax
bool	delex

bimage=im1
rimage=im2
iimage=im3
delex=delold

fileroot(bimage, validim+); imrootb=fileroot.root
fileroot(rimage, validim+); imrootr=fileroot.root
if(iimage!=""){
	numim=3
	fileroot(iimage, validim+); imrooti=fileroot.root
}
numim=2
image=bimage

#--for each image, mask out areas with <2/3 (rounded down) of all images
for (imnow=1; imnow<=numim; imnow+=1) {
	if(imnow==2){image=rimage}
	if(imnow==3){image=iimage}
	hsel (image, "plfmask", yes) | scan (pl)
	fileroot(image, validim+)
	imroot=fileroot.root
	imext=fileroot.extension
	fileroot(pl, validim+)
	pl=fileroot.root

#--create trim masks from pixel list files
	if(delex)imdel(pl//"good.pl", ver-, >& "dev$null")
	if(!access(pl//"good.pl")){
		minmax (pl, force+, update-, ver-)
		maxfrac = minmax.maxval/3.
		imdel ("tmp"//pl//".pl", ver-, >& "dev$null")
		imar (pl,"-",maxfrac,"tmp"//pl//".pl",ver-,noact-,calct="real",pixt="1")
		minv ("tmp"//pl, pl//"good.pl")
		imdel ("tmp"//pl, ver-)
	}

#--find x boundaries for trimming
	if(delex)imdel(pl//"trans.pl", ver-, >& "dev$null")
	if(!access(pl//"trans.pl"))imtransp(pl//"good.pl[*,-*]",pl//"trans.pl")
	minmax (pl//"trans.pl", force+, update-, ver-)
	s3=minmax.maxpix; i=stridx(",",s3); j=stridx("]",s3)
	s1=substr(s3,i+1,j-1); s1="["//s1//":"
	minmax (pl//"trans.pl[*,-*]", force+, update-, ver-)
	s3=minmax.maxpix; i=stridx(",",s3); j=stridx("]",s3)
	s2=substr(s3,i+1,j-1); k=real(s2)
	imgets (pl//"trans.pl", "i_naxis2")
	j=int(imgets.value); i=j-k+1; s1=s1//i//","
#	imdel (pl//"trans.pl", ver-)

#--find y boundaries for trimming
	minmax (pl//"good.pl", force+, update-, ver-)
	s3=minmax.maxpix; i=stridx(",",s3); j=stridx("]",s3)
	s2=substr(s3,i+1,j-1); s1=s1//s2//":"
	minmax (pl//"good.pl[*,-*]", force+, update-, ver-)
	s3=minmax.maxpix; i=stridx(",",s3); j=stridx("]",s3)
	s2=substr(s3,i+1,j-1); k=real(s2)
	imgets (pl//"good.pl", "i_naxis2")
	j=int(imgets.value); i=j-k+1; s1=s1//i//"]"

#--create trimmed images
	imdel("_tmp_"//image, ver-, >& "dev$null")
	imar(image,"*",pl//"good.pl","_tmp_"//image,ve-,noa-,calct="real",pixt="1")
	imcopy ("_tmp_"//image//s1, imroot//"trim", ver+)
	imdel ("_tmp_"//image, ver-)

}

#--do irshift2 & immatch.geomap on b & r images
irshift2 (bimage, rimage, pprefix, ssuffix)
immatch.geomap (pprefix//"br.geomapin."//ssuffix, pprefix//"br.geomapout."//ssuffix, INDEF, INDEF, INDEF, INDEF, fitgeo="shift")

#--do irshift2 & immatch.geomap on b & i images
if(iimage!=""){
	irshift2 (bimage, rimage, pprefix, ssuffix)
	immatch.geomap (pprefix//"bi.geomapin."//ssuffix, pprefix//"bi.geomapout."//ssuffix, INDEF, INDEF, INDEF, INDEF, fitgeo="shift")
}

#--figure out b & r trimming sections
#--extract real x & y offsets
fields (pprefix//"br.geomapout."//ssuffix, "1,2", lines="26-26") | scan (x,y)
#--round off to nearest integer
i=int(x+0.5); j=int(y+0.5)
#--get smallest & largest pixel coords of primary image
bxmin=1; hsel (bimage, "i_naxis1", yes) | scan (bxmax)
bymin=1; hsel (bimage, "i_naxis2", yes) | scan (bymax)
bxnewmin=bxmin; bxnewmax=bxmax; bynewmin=bymin; bynewmax=bymax
#--get ideal offset smallest pixel coords of trimmed 2nd image
rxminoff=1+i; ryminoff=1+j
#--get largest pixel coords of 2nd image
hsel (rimage, "i_naxis1", yes) | scan (rxmax)
hsel (rimage, "i_naxis2", yes) | scan (rymax)
rxnewmin=rxminoff; rxnewmax=rxmax; rynewmin=ryminoff; rynewmax=rymax
#--if ideal offset smallest pixel coords of trimmed 2nd image <0, adjust to =1
if(rxminoff<=0) {
	xoff=1-rxminoff; rxnewmin=1
	bxnewmin=bxmin+xoff
}
if(ryminoff<=0) {
	yoff=1-ryminoff; rynewmin=1
	bynewmin=bymin+yoff
}
#--get ideal offset largest pixel coords of trimmed 2nd image
rxmaxoff=bxmax+i; rymaxoff=bymax+j
#--if ideal offset largest 2nd image pixel coords larger than original 2nd image
if(rxmaxoff>rxmax) {
	xoff=rxmaxoff-rxmax; rxnewmax=rxmax
	bxnewmax=bxnewmax+xoff
}
if(rymaxoff>rymax) {
	yoff=rymaxoff-rymax; rynewmax=rymax
	bynewmax=bynewmax+yoff
}

#--trim imroot//"trim" to imroot//"align"
imcopy (imager//"["//rxnewmin//":"//rxnewmax//","//rynewmin//":"//rynewmax//"]", imrootr//"align")
imcopy (imageb//"["//bxnewmin//":"//bxnewmax//","//bynewmin//":"//bynewmax//"]", imrootb//"align")


#--figure out i trimming sections

#--display if desired

if(echog)beep

end

