# offone.cl -- find the first object within some radius of another on the sky
#
# Input format for both lists is:
# 1   2   3
# ra dec id#
#
# Output is:
# 1    2   3    4   5   6      7     
# id1 ra1 dec1 id2 ra2 dec2 distance 
#
# ...for the first object closer than "limit" if

procedure offone(list1,list2,outlist,limit)

string list1 {prompt = "First list of coordinates"}
string list2 {prompt = "Second list of coordinates"}
string outlist {prompt = "Output file"}
real limit {prompt = "Max separation, in arcmin, to save"}
#bool all {prompt = "List all objects closer than limit?"}
struct *el1
struct *el2

begin

real dist, cdist, sdist, tdist, rn1, rn2, dn1, dn2, rt1, rt2, sigdig, distold
real pa, cpa, spa, tpa, rd, dd, rds, dds, dt1, dt2, r1, r2, d1, d2, lim
real pi=3.141592653585
int ipa
string ir1, ir2, id1, id2, num1, num2, ooutlist, el3
string ir1old, ir2old, id1old, id2old, num1old, num2old
bool aall, go

el1=list1
el2=list2
el3=list2
ooutlist=outlist
lim=limit
distold=lim+1.
#aall=all
go=no

while(fscan(el1,ir1,id1,num1) !=EOF) {

    while(fscan(el2,ir2,id2,num2) !=EOF) {

#	print (num1//" "//num2)
	r1=real(ir1)
	d1=real(id1)
	r2=real(ir2)
	d2=real(id2)

#convert input RA to degrees
        rt1=15.0*r1
        rt2=15.0*r2
#convert input RA,dec to radians
        rn1=rt1*pi/180.0
        rn2=rt2*pi/180.0
        dn1=d1*pi/180.0
        dn2=d2*pi/180.0
#compute the distance using the formula:
#cosine(distance) = sin(dn1)*sin(dn2) + cos(dn1)cos(dn2)cos(rn2-rn1)
        cdist = sin(dn1)*sin(dn2) + cos(dn1)*cos(dn2)*cos(rn2-rn1)
	if(cdist**2>=1.00)cdist=1.00		#fixes roundoff prob
        sdist = sqrt(1.00 - cdist**2)
        tdist = atan2(sdist,cdist) 		#theta=atan2(y,x)
        dist = tdist*180.00/pi
##compute the position angle using the formula:
##cos(pa)=(cos(dn1)sin(dn2) - sin(dn1)cos(dn2)cos(rn2-rn1))/(sin(tdist))
#	#cpa = (cos(dn1)*sin(dn2) - sin(dn1)*cos(dn2)*cos(rn2-rn1))/(sdist)
#	cpa = cos(dn1)*sin(dn2) - sin(dn1)*cos(dn2)*cos(rn2-rn1)
#	if(sdist==0.0){
#		pa = 360.0
#	} else {
#		cpa = cpa/sdist
#		if(cpa**2>=1.00)cpa=1.00		#fixes roundoff prob
#        	spa = sqrt(1.00 - cpa**2)
#        	tpa = atan2(spa,cpa) 		#theta=atan2(y,x)
#        	pa = tpa*180.00/pi
#	}

#is this the closest match found so far for this object?
	if(dist*60<=lim){
		go=yes
		distold=dist
#output closest match
		print(num1//" "//ir1//" "//id1//"  "//num2//" "//ir2//" "//id2//" "//dist*60, >> ooutlist)
	}
#end el2 loop if match found
	if(go==yes)break

#end el2 loop
    }

distold=lim+1.
go=no
el2=el3

#end el1 loop
}

end

