# testfringe.cl -- test defringing with user-specified scalings

# 980729: created from checkfringe.cl

procedure testfringe(fiximage,fringe,outname)

string fiximage   {prompt="Name of (original) image to be defringed"}
string fringe     {prompt="Fringe image to scale and subtract"}
string outname    {prompt="Name of final defringed image to create"}
real startscale=0. {prompt="First scaling to use (0.=default calculated)",mode="q"}
real stepscale=0. {prompt="Step between scaling values (0.=default=0.05)",mode="q"}
int nsteps=0	  {prompt="Number of test images to make (0=until RMS rises)",mode="q"}
string imsect=""  {prompt="[Image section] to use for statistics & display"}
bool   addhead=no {prompt="Add iterstat output to image header?"}
bool   display=no {prompt="Display defringed image sections?"}
bool   fit=yes    {prompt="Adjust parameters and retest defringing?",mode="q"}
real   scale      {prompt="Scaling to use on fringe image",mode="q"}
real   finalscale {prompt="Scaling to use for final image",mode="q"}
bool   finaldisp  {yes,prompt="Display original & final images when done?"}
#int    z=0        {prompt="Number of image to save?",mode="q"}
bool   echog        {yes,prompt="Beep when task is done?"}

begin

string logimex, logsurf, rrootname, ooutname, ffunc
string wweighting, fiximg, ffringe, titlestring, statsec
real max, nncols, nnlines, sscale, indiv_exptime, avg_exptime, sum_exptime
real sc_start, sc_step, itermed, oldrms, newrms, sc_final, ll, ul, mn, sig
int x, y, zz, xxord, yyord, xx, steps, w, nx, npx, m
bool go, ffit, xxterms, ddisplay, hadd, disfinal

fiximg=fiximage
ffringe=fringe
ooutname=outname

sc_start=startscale
sc_step=stepscale
if(sc_step==0.)sc_step=0.05
steps=nsteps
if(steps==0)steps=999

statsec=imsect
hadd=addhead
ddisplay=display
disfinal=finaldisp
zz=0

# check for imcalc & addcomment; if not defined abort task.
go=yes
if(!deftask("addcomment")) {go=no}
if(!deftask("imcalc")) {go=no}
if(go) {

# Get initial scaling
	if(ddisplay) {
		print("===> Displaying fringe & original image sections & iterstating the latter...")
		display(ffringe//statsec,1)
		display(fiximg//statsec,2)
	} else {
		print("===> Iterstating original image section...")
	}
	iterstat (fiximg//statsec,nsigrej=5.,maxiter=10,lower=INDEF,upper=INDEF,print+,ver-,addh=hadd)
	oldrms=iterstat.sigma
        if(sc_start!=0.){
		sscale=sc_start
	} else {
		imgets(fiximg,"FRINGMED",>&"dev$null")
		if(imgets.value!="0"){
			sscale=real(imgets.value)
		} else {
        		imgets(ffringe,"exptime")
			avg_exptime=real(imgets.value)
        		imgets(fiximg,"exptime")
			indiv_exptime=real(imgets.value)
        		sscale=indiv_exptime/avg_exptime
		}
	}

print ("===> Begin loop of subtracting scaled fringe images...") 
x=1; y=2; ffit=yes
# Optional multiple loop
while(ffit) {
# Loop over requested scalings
    for (w=1; w<1+steps; w+=1) {
# if new image...
	if(w!=1){
# ...get new scaling
		sscale=sscale+sc_step
	}
# subtract the scaled fringe image 
#        print ("===> Scaling fringe image by "//sscale//" and subtracting...") 
	imcalc(fiximg//statsec//","//ffringe//statsec,ooutname//"_"//str(sscale),"im1-im2*"//sscale,ver-)
#imcalc(fiximg//","//ffringe,ooutname//"_"//str(sscale),"im1-im2*"//sscale,ver-)
  	hedit(ooutname//"_"//str(sscale),"title","Defringed image using scale="//sscale,ver-,add+,update+,show-)

# display & iterstat the subtracted image 
	if(ddisplay){
#		print ("===> Displaying & iterstating defringed image #"//str(sscale)//statsec//"...")
		y=y+1
		if(y>4)y=1
		displ (ooutname//"_"//str(sscale), y)
#displ (ooutname//"_"//str(sscale)//statsec, y)
	}
#	iterstat (ooutname//"_"//str(sscale),nsigrej=5.,maxiter=10,lower=INDEF,upper=INDEF,print+,ver-,addh=hadd)
	imstat (ooutname//"_"//str(sscale),fields="mean,stddev,npix",lower=INDEF,upper=INDEF,for-) | scan(mn,sig,npx)
        m = 1
	while (m <= 10)  {
		ll = mn-5*sig
                ul = mn+5*sig
		imstat (ooutname//"_"//str(sscale),fields="mean,stddev,npix",lower=ll,upper=ul,for-) | scan(mn,sig,nx)
		if (nx == npx)
			break
                npx = nx
		m = m + 1
        }
	print ("RMS of image "//ooutname//"_"//str(sscale)//" is "//sig)
	imdel (ooutname//"_"//str(sscale),ver-)
#iterstat (ooutname//"_"//str(sscale)//statsec,nsigrej=5.,maxiter=10,lower=INDEF,upper=INDEF,print+,ver-,addh=hadd)
#	newrms=iterstat.sigma
	newrms=sig
	if(steps==999){
		if(newrms>=oldrms){
			w=1001
			beep
		}
	}
	oldrms=newrms
        x+=1
    }

# optional multiple loop -- try another set of values?
    ffit=fit
    if(ffit) {
	sc_start=startscale
	sscale=sc_start
	sc_step=stepscale
	if(sc_step==0.)sc_step=0.05
	steps=nsteps
	if(steps==0)steps=999
    }
    
    }

# ask for sscale and create full-size final image
sc_final=finalscale
if(sc_final!=0){
    print("Creating final image...")
    imcalc(fiximg//","//ffringe,ooutname,"im1-im2*"//sc_final,ver-)
    hedit(ooutname,"FRINGMED",sc_final,add+,ver-,show-,update+)
    addcomment(ooutname,"Defringed using FRINGMED-scaled copy of "//ffringe,ve-)
#   hedit(ooutname,"title","Defringed image using scale="//sscale,ver-,add+,update+,show-)
} else {
    print("No images saved.")
}

if(disfinal){
	print("===> Displaying original and defringed images...")
	displ(fiximg, 1)
	displ(ooutname, 2)
}

## clean up
#y=0; zz=0
#while(y<x){
#	imdel(ooutname//"_"//str(y),ver-, >& "dev$null")
#	y+=1
#}

}
else{
print("Tasks stsdas.toolbox.imgtools.imcalc & phiirs.addcomment aren't loaded,")
print("and this task needs them to run.  Please load them and start again.")
}

if(echog)beep

end
